Is Regression: No
Sprint Focus: Stabilization Sprint
Subject: Content Slide: slide.collect issues since 7.1.0
Description

Hello,

I have created a 6.2.5 Website last year. On this website I use the content slide feature:

content_bottom_bottom < styles.content.get
content_bottom_bottom.select.where = colPos=4
content_bottom_bottom.slide = -1
content_bottom_bottom.slide.collect = -1

It all worked well - until I upgraded to 7.2. All the sudden the website wasn't working any longer, and I boiled the error down to one
line:

content_bottom_bottom.slide.collect = -1

I have seven content blocks which use the slide feature, so this line (with a different variable) appears seven times in my code. With
those lines active my frontend turns into an infinite loop of waiting (not even the 240 seconds PHP execution time, but literally
infinite!).

Removing slide.collect seemed to work fine at first, but logically it means that inherited content won't be displayed if the block has its
own content (which is what I need). I figured, since -1 means that TYPO3 will collect content all the way up to the root element, I could
set it to 5 to reflect the amount of layers I have to the root element. That seemed to work as well, but it had the following effects:

I have a layout like this:

Root
- Website (Shortcut to Homepage, contains a few content blocks which are inherited by EVERY page)
- - Homepage (Contains a block which is inherited by selected pages)
- - - Imprint (inherits the footer from "Website" 
- - - ...
- - - Some page (is deactivated, but required so .slide works, since sysfolder breaks it)
- - - - Subpage which inherits the footer from "Website" and the single block from "Homepage"

Case A: Subpage

I inserted a divider to "content_bottom_bottom". Instead of displaying it like this:
------------------
Inherited content

I got this:

------------------
Inherited content
------------------

So the additional content is added above AND below the inherited content.
Everything else was fine.

Case B: Homepage

Each element of the footer (from "Website") appeared two times:

A1      A2
A1      A2

A3  A4  A5
A3  A4  A5

And the single element that is inherited to selected subpages appears three (!) times!

Case C: Imprint

Everything works fine. Just like "Subpage" the footer only appeared once. Since it doesn't inherit the block of "Homepage" (unlike
"Subpage") there was no other problem.

I decided to try older version of the 7.x-branch. I started with 7.0.0, and here everything worked fine: I was even able to set
.slide.collect back to -1, so my extension was identical to how it works in the 6.2.5 live installation. Then I tried it with 7.1.0 - and it
stopped working. Same behaviour as 7.2!

My testing machine is a Debian 8 virtual machine with Apache and PHP 5.6.7. A test on Windows Vista + PHP 5.5 with TYPO3
Version 7.2 brought up the same result.

Related issues:
related to Core - Task # 54091: Use === operator instead of strlen() to check... Resolved 2013-11-29

Associated revisions
Revision bde48583 - 2015-06-15 12:52 - Benjamin Mack

[BUGFIX] CONTENT cObject slide does not loop

The CONTENT cObject is looping over the SQL query
when sliding the rootline and/or collecting but never
repeats due to missing braces.

This happened during a cleanup merge in commit
4722b6cf5c97ab415d3d35687ed77750b97e3258.

The patch re-adds the braces.
Resolves: #67034
Related: #54091
Releases: master
Change-Id: Ifc912ea8d5d2861d6888ddc5ac7bd755e3ff6bb4
Reviewed-on: http://review.typo3.org/40244
Reviewed-by: Markus Klein <markus.klein@typo3.org>
Tested-by: Markus Klein <markus.klein@typo3.org>
Reviewed-by: Andreas Fernandez <typo3@scripting-base.de>
Tested-by: Andreas Fernandez <typo3@scripting-base.de>

History
#1 - 2015-05-19 18:50 - Wouter Wolters
- Target version deleted (7.1 (Cleanup))

#2 - 2015-05-20 14:17 - Markus Klein

There have been some changes to this area. I suspect that it has something to do with "Website" being a shortcut, but I'm not sure yet.

#3 - 2015-05-20 14:18 - Markus Klein
- Assigned To set to Markus Klein
- Target version set to 7.3 (Packages)
- Sprint Focus set to Stabilization Sprint

#4 - 2015-05-20 14:19 - Markus Klein
- Assigned To changed from Markus Klein to Benjamin Mack

#5 - 2015-06-15 12:47 - Gerrit Code Review
- Status changed from New to Under Review

Patch set 1 for branch master of project Packages/TYPO3.CMS has been pushed to the review server.
It is available at http://review.typo3.org/40244

#6 - 2015-06-15 13:00 - Benjamin Mack
- Status changed from Under Review to Resolved
- % Done changed from 0 to 100

Applied in changeset commit:bde48583c67d54f13a4ba0295545bdef631934fb.
